
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Contract_amendmentsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contract_amendments = await db.contract_amendments.create(
            {
                id: data.id || undefined,
        
        amendment_number: data.amendment_number
        ||
        null
            ,
            
        amendment_type: data.amendment_type
        ||
        null
            ,
            
        value_change_amount: data.value_change_amount
        ||
        null
            ,
            
        days_extension: data.days_extension
        ||
        null
            ,
            
        description: data.description
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        effective_date: data.effective_date
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await contract_amendments.setContract( data.contract || null, {
            transaction,
        });
        
        await contract_amendments.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return contract_amendments;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const contract_amendmentsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                amendment_number: item.amendment_number
            ||
            null
            ,
            
                amendment_type: item.amendment_type
            ||
            null
            ,
            
                value_change_amount: item.value_change_amount
            ||
            null
            ,
            
                days_extension: item.days_extension
            ||
            null
            ,
            
                description: item.description
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                effective_date: item.effective_date
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const contract_amendments = await db.contract_amendments.bulkCreate(contract_amendmentsData, { transaction });

        // For each item created, replace relation files
        

        return contract_amendments;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const contract_amendments = await db.contract_amendments.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.amendment_number !== undefined) updatePayload.amendment_number = data.amendment_number;
        
        
        if (data.amendment_type !== undefined) updatePayload.amendment_type = data.amendment_type;
        
        
        if (data.value_change_amount !== undefined) updatePayload.value_change_amount = data.value_change_amount;
        
        
        if (data.days_extension !== undefined) updatePayload.days_extension = data.days_extension;
        
        
        if (data.description !== undefined) updatePayload.description = data.description;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.effective_date !== undefined) updatePayload.effective_date = data.effective_date;
        
        
        updatePayload.updatedById = currentUser.id;

        await contract_amendments.update(updatePayload, {transaction});

        
        
        if (data.contract !== undefined) {
            await contract_amendments.setContract(
              
              data.contract,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await contract_amendments.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return contract_amendments;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const contract_amendments = await db.contract_amendments.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of contract_amendments) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of contract_amendments) {
                await record.destroy({transaction});
            }
        });


        return contract_amendments;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const contract_amendments = await db.contract_amendments.findByPk(id, options);

        await contract_amendments.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await contract_amendments.destroy({
            transaction
        });

        return contract_amendments;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const contract_amendments = await db.contract_amendments.findOne(
            { where },
            { transaction },
        );

        if (!contract_amendments) {
            return contract_amendments;
        }

        const output = contract_amendments.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.contract = await contract_amendments.getContract({
            transaction
        });
        
        
        output.organizations = await contract_amendments.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.contracts,
        as: 'contract',
        
        where: filter.contract ? {
          [Op.or]: [
            { id: { [Op.in]: filter.contract.split('|').map(term => Utils.uuid(term)) } },
            {
              contract_number: {
                [Op.or]: filter.contract.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.amendment_number) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contract_amendments',
                        'amendment_number',
                        filter.amendment_number,
                    ),
                };
            }
            
            if (filter.description) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'contract_amendments',
                        'description',
                        filter.description,
                    ),
                };
            }
            

            
            

            
            if (filter.value_change_amountRange) {
                const [start, end] = filter.value_change_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    value_change_amount: {
                    ...where.value_change_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    value_change_amount: {
                    ...where.value_change_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.days_extensionRange) {
                const [start, end] = filter.days_extensionRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    days_extension: {
                    ...where.days_extension,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    days_extension: {
                    ...where.days_extension,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.effective_dateRange) {
                const [start, end] = filter.effective_dateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    effective_date: {
                    ...where.effective_date,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    effective_date: {
                    ...where.effective_date,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.amendment_type) {
                where = {
                    ...where,
                amendment_type: filter.amendment_type,
            };
            }
            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.contract_amendments.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'contract_amendments',
                        'amendment_number',
                        query,
                    ),
                ],
            };
        }

        const records = await db.contract_amendments.findAll({
            attributes: [ 'id', 'amendment_number' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['amendment_number', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.amendment_number,
        }));
    }

    
};

